class RenderToTexture
{
  Texture m_tex;
  int m_w, m_h;

  RenderToTexture(int w, int h)
  {
    m_tex = new Texture();  
    m_tex.createBlank(w,h);
    m_w = m_tex.width;
    m_h = m_tex.height;
  }

  void M_bindTexture()
  {
    opengl.glEnable(GL.GL_TEXTURE_2D);
    opengl.glBindTexture(GL.GL_TEXTURE_2D, m_tex.texName[0]);
  }

  void M_unbindTexture()
  {
    opengl.glDisable(GL.GL_TEXTURE_2D);  
  }

  void M_begin()
  {
    opengl.glViewport(0,0,m_w,m_h);
    opengl.glScissor(0,0,m_w,m_h);
  }

  void M_end()
  {
    M_bindTexture();
    opengl.glCopyTexSubImage2D(GL.GL_TEXTURE_2D, 0, 0, 0, 0, 0, m_w, m_h);
    M_unbindTexture();  
  }

}
